/*
			Copyright (c) 1994 by
			Advanced Visual Systems Inc.
			All Rights Reserved
	
	This software comprises unpublished confidential information of
	Advanced Visual Systems Inc. and may not be used, copied or made
	available to anyone, except in accordance with the license
	under which it is furnished.
	
	This file is under Perforce control
	$Id: //depot/express/fcs992/include/avs/wt.h#1 $
*/

/* Header file for the WT subsystem */

/*---------------------------------------------------------------------*/

/* Prevent the contents of this file from being included more than once */

#ifndef _WT_H_INCLUDED
#define _WT_H_INCLUDED

/*---------------------------------------------------------------------*/

/* Header files */

#include <avs/wt_type.h>

/*--------------------------------------------------------------------*/
/*                       Function prototypes                          */
/*--------------------------------------------------------------------*/

#ifdef __cplusplus  /* Do not leave open across includes */
extern "C" {        /* For C++ V2.0 */
#endif

/* From bmp.c */

void *
WTopen_bmp_file PTARGS((
    char  *filename,
    int   access));

void
WTclose_bmp_file PTARGS((
    void  *bmp));

WTstatus
WTget_bmp_width PTARGS((
    void  *bmp,
    int   *width));

WTstatus
WTget_bmp_height PTARGS((
    void  *bmp,
    int   *height));

WTstatus
WTget_bmp_ARGB_image PTARGS((
    void           *bmp,
    unsigned char  **data));

/* From context.c */

WTdisp *
WTcreate_disp PTARGS((
    WTsys_wind  ref_wind));

void
WTset_disp_pixel_func PTARGS((
    WTdisp        *disp,
    WTpixel_func  func,
    void           *data));

WTpixel
WTget_pixel PTARGS((
    WTdisp   *disp,
    WTcolor  color));

void
WTget_pixel_rgb_values PTARGS((
    WTdisp   *disp,
    WTpixel  pixel,
    WTcoord  *r,
    WTcoord  *g,
    WTcoord  *b));

void
WTadd_root_window PTARGS((
    WTdisp  *disp,
    WTwind  *window));

void
WTdelete_root_window PTARGS((
    WTdisp  *disp,
    WTwind  *window));

void
WThide_pending PTARGS((
    WTdisp  *disp));

void
WTshow_pending PTARGS((
    WTdisp  *disp));

/* From cursor.c */

void
WTset_cursor PTARGS((
    WTsys_wind      sys_wind,
    WTcursor_class  cursor_class));

/* From decor.c */

WTdecor_ptr
WTinstall_decor PTARGS((
    WTdisp         *disp,
    WTdecor_class  decor_class,
    WTpixel        bg_pixel,
    WTsys_wind     ref_wind,
    WTcoord        bevel_thickness));

void
WTuninstall_decor PTARGS((
    WTdecor_ptr  decor));

void
WTset_wind_decor PTARGS((
    WTwind       *window,
    WTdecor_ptr  decor));

void
WTadd_decor_event_handler PTARGS((
    WTwind  *window));

void
WTdraw_bevel_rect PTARGS((
    WTwind       *window,
    WTdecor_ptr  decor, 
    WTcoord  x,
    WTcoord  y, 
    WTcoord  width,
    WTcoord  height,
    WTcoord  thickness,
    int       reverse));

void
WTdraw_separator PTARGS((
    WTwind       *window,
    WTdecor_ptr  decor,
    int       horiz,
    WTcoord  min,
    WTcoord  max, 
    WTcoord  loc,
    WTcoord  thickness));

void
WTdraw_border PTARGS((
    WTwind       *window,
    WTdecor_ptr  decor,
    WTcoord  x,
    WTcoord  y,
    WTcoord  width,
    WTcoord  height));

WTpixel
WTget_decor_bg_pixel PTARGS((
    WTdecor_ptr  decor));

WTpixel
WTget_decor_fg_pixel PTARGS((
    WTdecor_ptr  decor));

WTpixel
WTget_decor_top_pixel PTARGS((
    WTdecor_ptr  decor));

WTpixel
WTget_decor_bottom_pixel PTARGS((
    WTdecor_ptr  decor));

WTpixel
WTget_decor_highlight_pixel PTARGS((
    WTdecor_ptr  decor));

WTpixel
WTget_decor_bevel_thickness PTARGS((
    WTdecor_ptr  decor));

/* From ev_hndlr.c */

void
WTadd_event_handler PTARGS((
    WTwind                *window,
    unsigned int           mask,
    WTevent_handler_func  func,
    void                   *arg));

void
WTdelete_event_handler PTARGS((
    WTwind                *window,
    unsigned int           mask,
    WTevent_handler_func  func,
    void                   *arg));

void
WTdelete_all_event_handlers PTARGS((
    WTwind  *window));

void
WTadd_callback PTARGS((
    WTwind             *window,
    WTcallback_reason  reason,
    WTcallback_func    func,
    void                *arg));

void
WTdelete_callback PTARGS((
    WTwind             *window,
    WTcallback_reason  reason,
    WTcallback_func    func,
    void                *arg));

void
WTset_timer PTARGS((
    WTwind                *window,
    unsigned int           interval,
    WTevent_handler_func  func,
    void                   *arg));

void
WTclear_timer PTARGS((
    WTwind  *window));

/* From event.c */

void
WTdeliver_button_press_event PTARGS((
    WTwind       *window,
    int           x,
    int           y,
    unsigned int  button,
    int           shift,
    int           control,
    int           dclick,
    unsigned int  time));

void
WTdeliver_button_motion_event PTARGS((
    WTwind       *window,
    int           x,
    int           y,
    unsigned int  time));

void
WTdeliver_button_release_event PTARGS((
    WTwind       *window,
    int           x,
    int           y,
    unsigned int  button,
    unsigned int  time));

void
WTdeliver_expose_event PTARGS((
    WTwind  *window));

void
WTdeliver_resize_event PTARGS((
    WTwind  *window,
    int      x,
    int      y,
    int      width,
    int      height));

void
WTdeliver_visibility_event PTARGS((
    WTwind  *window,
    int      visibility));

void
WTdeliver_enter_event PTARGS((
    WTwind  *window));

void
WTdeliver_leave_event PTARGS((
    WTwind  *window));

void
WTdeliver_timer_event PTARGS((
    WTwind  *window));

void
WTcall_callback PTARGS((
    WTwind             *window,
    WTcallback_reason  reason,
    void                *arg));

void
WTset_event_pre_handler PTARGS((
    WTevent_handler_func  func,
    void                   *arg));

void
WTset_event_post_handler PTARGS((
    WTevent_handler_func  func,
    void                   *arg));

/* From ned.c */

WTwind *
WTcreate_wind PTARGS((
    WTdisp       *disp,
    WTwind       *parent,
    WTsys_wind   parent_sys_wind,
    WTwind_type  *type,
    WTcoord      x,
    WTcoord      y,
    WTcoord      width,
    WTcoord      height,
    WTcoord      offx,
    WTcoord      offy,
    double        scale,
    WTdecor_ptr  decor));

void
WTrealize_wind PTARGS((
    WTwind  *wind));

void
WTdestroy_wind PTARGS((
    WTwind  *wind));

void
WTactually_destroy_wind PTARGS((
    WTwind  *wind));

void
WTset_wind_background PTARGS((
    WTwind   *window,
    WTpixel  pixel));

void
WTset_wind_background_pixmap PTARGS((
    WTwind        *window,
    WTpixmap_ptr  pixmap));

void
WTenable_wind PTARGS((
    WTwind  *window,
    int      state));

void
WTadd_wind_udata PTARGS((
    WTwind  *wind,
    void     *uptr,
    char     *name));

void *
WTget_wind_udata PTARGS((
    WTwind  *wind,
    char     *name,
    int      parent));

void
WTmap_wind PTARGS((
    WTwind  *wind,
    int      state));

int
WTraise_wind PTARGS((
    WTwind  *wind,
    int     force));

void
WTtranslate_wind PTARGS((
    WTwind   *wind,
    int       mode,
    WTcoord  tx,
    WTcoord  ty));

void
WTscale_wind PTARGS((
    WTwind   *wind,
    int       mode,
    float     scale,
    WTcoord  cx,
    WTcoord  cy));

void
WTupd_scale PTARGS((
    WTwind  *wind));

void
WThighlight_wind PTARGS((
    WTwind  *wind,
    int      state));

void
WTmove_wind PTARGS((
    WTwind   *wind,
    int       mode,
    WTcoord  x,
    WTcoord  y));

void
WTresize_wind PTARGS((
    WTwind   *wind,
    int       mode,
    WTcoord  w,
    WTcoord  h));

void
WTreshape_wind PTARGS((
    WTwind   *wind,
    WTcoord  x,
    WTcoord  y,
    WTcoord  w,
    WTcoord  h));

int
WTfind_wind_by_xy PTARGS((
    WTwind   *wind,
    int       xi,
    int       yi,
    WTwind   **chld_wind,
    WTcoord  *ch_x,
    WTcoord  *ch_y));

WTcoord 
WTmap_to_ancestor_x PTARGS((
    WTwind   *wind,
    WTwind   *pwind,
    WTcoord  x));

WTcoord 
WTmap_to_ancestor_y PTARGS((
    WTwind   *wind,
    WTwind   *pwind,
    WTcoord  y));

WTcoord 
WTmap_to_ancestor_w PTARGS((
    WTwind   *wind,
    WTwind   *pwind,
    WTcoord  w));

WTcoord 
WTmap_to_ancestor_h PTARGS((
    WTwind   *wind,
    WTwind   *pwind,
    WTcoord  h));

void
WTset_focus PTARGS((
    WTwind  *window));

void
WTmap_ancestor_xy PTARGS((
    WTwind   *from_wind,
    WTcoord  from_x,
    WTcoord  from_y,
    WTwind   *to_wind,
    WTcoord  *to_x,
    WTcoord  *to_y));

void
WTmap_to_ancestor_xy PTARGS((
    WTwind   *from_wind,
    WTcoord  from_x,
    WTcoord  from_y,
    WTwind   *to_wind,
    WTcoord  *to_x,
    WTcoord  *to_y));

void
WTget_window_pixel_geom PTARGS((
    WTwind       *window,
    int           *x,
    int           *y,
    unsigned int  *width,
    unsigned int  *height));

void
WTmap_position PTARGS((
    WTwind   *window,
    WTcoord  x,
    WTcoord  y,
    int       *xi,
    int       *yi));

void
WTunmap_position PTARGS((
    WTwind   *window,
    int       xi,
    int       yi,
    WTcoord  *x,
    WTcoord  *y));

WTwind *
WTsys_wind_to_window PTARGS((
    WTsys_wind  sys_wind));

void
WTerase_window_bg PTARGS((
    WTwind  *window));

#ifndef MSDOS
void
WTset_xmtext_string PTARGS((
    Widget  w,
    char    *string));
#endif

/* From optmenu.c */

void
WTsetup_option_menu PTARGS((
    WTwind  *window,
    char     **strings,
    int      num_strings));

void
WTselect_option_menu_item PTARGS((
    WTwind  *window,
    int      item));

/* From pixel.c */

WTpixel
WTdefault_pixel_func PTARGS((
    WTdisp   *disp,
    WTcolor  color,
    void      *data));

/* From pixmap.c */

WTpixmap_ptr
WTinstall_pixmap PTARGS((
    WTdisp         *disp,
    char           *name,
    WTpixmap_type  type));

int
WTpixmap_matches PTARGS((
    WTpixmap_ptr   pixmap,
    WTdisp         *disp,
    char           *name,
    WTpixmap_type  type));

void
WTpixmap_size PTARGS((
    WTpixmap_ptr  pixmap,
    int            *width,
    int            *height));

void
WTdraw_pixmap PTARGS((
    WTpixmap_ptr  pixmap,
    WTwind        *wind,
    WTcoord       x,
    WTcoord       y));

void
WTupdate_direct_pixmaps PTARGS((
    WTdisp  *disp));

#ifdef MSDOS

HBRUSH
WTget_pixmap_hbrush PTARGS((
    WTpixmap_ptr  pixmap));

#else

Pixmap
WTget_X_pixmap PTARGS((
    WTpixmap_ptr  pixmap));

#endif

WTpixel
WTget_main_pixmap_pixel PTARGS((
    WTpixmap_ptr  pixmap));

char *
WTget_pixmap_filename PTARGS((
    char  *name));

void
WTset_pixmap_path PTARGS((
    char  *path));

/* From popupmnu.c */

WTpopup_menu
WTcreate_popup_menu PTARGS((
    WTwind         *window,
    WTfontset_ptr  fontset));

void
WTappend_menu PTARGS((
    WTpopup_menu  menu,
    int            flags,
    int            id,
    char           *string));

void
WTtrack_popup_menu PTARGS((
    WTpopup_menu  menu,
    WTwind        *window,
    int            x,
    int            y));

/* From prim.c */

void
WTclear_wind PTARGS((
    WTwind  *window,
    int      refresh));

void
WTrefresh_wind PTARGS((
    WTwind  *window));

void
WTdraw_rect_pixel PTARGS((
    WTwind   *window,
    WTpixel  pixel, 
    WTcoord  x1,
    WTcoord  y1,
    WTcoord  x2,
    WTcoord  y2));

void
WTdraw_rect PTARGS((
    WTwind   *window,
    WTcolor  color, 
    WTcoord  x1,
    WTcoord  y1,
    WTcoord  x2,
    WTcoord  y2));

void
WTdraw_polygon_pixel PTARGS((
    WTwind   *window,
    WTpixel  pixel,
    WTvec2   *verts,
    int       num_verts));

void
WTdraw_polygon PTARGS((
    WTwind   *window,
    WTcolor  color,
    WTvec2   *verts,
    int       num_verts));

void
WTdraw_polyline_pixel PTARGS((
    WTwind   *window,
    WTpixel  pixel,
    WTcoord  line_width,
    WTvec2   *verts,
    int      num_verts));

void
WTdraw_polyline PTARGS((
    WTwind   *window,
    WTcolor  color,
    WTcoord  line_width,
    WTvec2   *verts,
    int      num_verts));

void
WTdraw_rainbow_polyline PTARGS((
    WTwind   *window,
    WTcolor  *colors,
    int       num_colors,
    WTcoord  line_width,
    WTvec2   *verts,
    int       num_verts));

void
WTdraw_xor_box PTARGS((
    WTwind   *window,
    WTcolor  color,
    WTcoord  x,
    WTcoord  y,
    WTcoord  width,
    WTcoord  height));

void
WTinstall_rubberband PTARGS((
    WTwind   *window,
    WTcolor  color,
    WTcoord  x,
    WTcoord  y,
    WTcoord  width,
    WTcoord  height));

void
WTuninstall_rubberband PTARGS((
    WTwind   *window,
    WTcolor  color,
    WTcoord  x,
    WTcoord  y,
    WTcoord  width,
    WTcoord  height));

void
WTflush PTARGS((
    WTwind  *window));

void
WTsync PTARGS((
    int  state));

void
WTsync_flush PTARGS((
    WTwind  *window));

/* From scrllbar.c */

void
WTupdate_scrollbar PTARGS((
    WTwind  *window));

/* From text.c */

WTfontset_ptr
WTinstall_fontset PTARGS((
    WTsys_disp         sys_disp,
    WTfont_attributes  *attributes,
    unsigned int       mask));

WTfontset_ptr
WTinstall_scaled_fontset PTARGS((
    WTfontset_ptr  src_fontset,
    int            height));

void
WTdestroy_display_font_info PTARGS((
    WTsys_disp  sys_disp));

void
WTdraw_text PTARGS((
    WTwind                *window,
    WTfontset_ptr         fontset,
    WTcoord               x,
    WTcoord               y,
    char                  *string,
    WTtext_justification  justification,
    int                   unhighlight));

int
WTtext_width PTARGS((
    WTfontset_ptr  fontset,
    char           *string));

int
WTget_font_height PTARGS((
    WTfontset_ptr  fontset));

#ifdef WIN32

HFONT
WTget_hfont PTARGS((
    WTfontset_ptr  fontset));

#else /* not WIN32 */

XFontSet
WTget_xfontset PTARGS((
    WTfontset_ptr  fontset));

XmFontList
WTget_xmfontlist PTARGS((
    WTfontset_ptr  fontset));

/* Backward-compatibility functions from text.c */

int
WTtext_width_default PTARGS((
    char  *string));

char *
WTget_default_font PTARGS((
    LocaleCSet cset));

/* End of backward-compatibility functions from text.c */

#endif /* not WIN32 */

/* From typein.c */

char *
WTget_typein_string PTARGS((
    WTwind  *window));

void
WTset_typein_string PTARGS((
    WTwind  *window,
    char     *string));

void
WTset_typein_insert_position PTARGS((
    WTwind  *window,
    int     position));

void
WTset_typein_selection PTARGS((
    WTwind  *window,
    int     start,
    int     end));

int
WTtypein_modified PTARGS((
    WTwind  *window));

/* From window.c */

int
WTis_wind_descendant PTARGS((
    WTwind  *wind,
    WTwind  *parent));

void
WTconvert_position PTARGS((
    WTwind   *from_wind,
    WTcoord  from_x,
    WTcoord  from_y,
    WTwind   *to_wind,
    WTcoord  *to_x,
    WTcoord  *to_y));

void
WThandle_sys_wind_destroy PTARGS((
    WTwind  *window));

void
WTset_palette_handler PTARGS((
    void (*func)(WTsys_wind, WTsys_pal) ));

void
WTset_palette PTARGS((
    WTsys_wind wind,
    WTsys_pal  pal ));

#ifdef MSDOS

/* From wndproc.c */

LRESULT CALLBACK
WTwnd_proc PTARGS((
    HWND    hwnd,
    UINT    message,
    WPARAM  wParam,
    LPARAM  lParam));

VOID CALLBACK
WTtimer_handler PTARGS((
    HWND   hwnd,
    UINT   msg,
    UINT   id,
    DWORD  time));

void
WTrelease_capture PTARGS((void));

#else /* not MSDOS */

/* From xevent.c */

void
WTxevent_handler PTARGS((
    Widget     w,
    XtPointer  client_data,
    XEvent     *event,
    Boolean    *continue_dispatch));

void
WTtimer_handler PTARGS((
    char  *client_data));

/* From xutil.c */

int WTexpose_events_queued PTARGS((
    Display  *display,
    Window   window));

#endif  /* not MSDOS */

#ifdef __cplusplus
}  /* End extern "C" */
#endif

/*--------------------------------------------------------------------*/

#endif /* _WT_H_INCLUDED */
/* DON'T ADD ANYTHING AFTER THIS #endif */
